#!/usr/bin/perl

$width=22;
$symlimit=0x80;

############

$chridx=0;
%elements = ();
$pixeldata='';

sub regchar
{
   ($chr,$pixels)=@_;
   $elements{$chr}=$chridx;
   $elemchars.=$chr;
   $pixeldata.="; char $chridx (source $chr)\n";
   $chridx++;

   foreach(split("\n",$pixels))
   {
         s/\_/01/g;	# 0 = bord
         s/\./10/g;	# 6 = fg
	  s/x/00/g;	# x = bg
	 s/\*/11/g;	# 1 = aux

         $pixeldata.=".byt \%$_\n";      
   }
   $pixeldata.="\n";
}

sub regch2
{
   ($chr,$pixels)=@_;
   $elements{$chr}=$chridx;
   $elemchars.=$chr;
   $pixeldata.="; char $chridx (source $chr)\n";
   $chridx++;

   foreach(split("\n",$pixels))
   {
	tr/.q/10/;

         $pixeldata.=".byt \%$_\n";      
   }
   $pixeldata.="\n";
}

sub regcharx
{
   my($chr,$pixels)=@_;
   $pixels =~ tr/_x.*/*x*_/;
   regchar($chr,$pixels);
}
# .* ok

sub regch2i
{
   my($chr,$pixels)=@_;
   $pixels =~ tr/.q/q./;
   regch2($chr,$pixels);
}

&regchar(' ',<<EOD);
____
____
____
____
____
____
____
____
EOD

&regchar('1',<<EOD);
****
.xxx
.xxx
.xxx
.xxx
.xxx
.xxx
.xxx
EOD

# explosive char 0

&regcharx('explosive0a',<<EOD);
x*.x
.x*.
*.x*
x*.x
.x*.
*.x.
x*.x
.x**
EOD

&regcharx('explosive0b',<<EOD);
*.x.
x*.x
.x*.
*.x*
x**.
.x*.
*.x*
.*x.
EOD

&regchar('2',<<EOD);
****
xxxx
xxxx
xxxx
xxxx
xxxx
xxxx
xxxx
EOD

&regchar('3',<<EOD);
****
xxx*
xxx*
xxx*
xxx*
xxx*
xxx*
xxx*
EOD

&regcharx('explosive1a',<<EOD);
x.*x
*.*.
.*.x
*.x*
.*x.
.x.x
x.*x
*x*.
EOD

&regcharx('explosive1b',<<EOD);
.*.x
*x*.
.*.x
x.x*
.x**
x..x
.*x.
*x.x
EOD

&regchar('4',<<EOD);
.xxx
.xxx
.xxx
.xxx
.xxx
.xxx
.xxx
.xxx
EOD

&regchar('5',<<EOD);
xxxx
xxxx
xxxx
xxxx
xxxx
xxxx
xxxx
xxxx
EOD

&regchar('6',<<EOD);
xxx*
xxx*
xxx*
xxx*
xxx*
xxx*
xxx*
xxx*
EOD

&regchar('7',<<EOD);
.xxx
.xxx
.xxx
.xxx
.xxx
.xxx
.xxx
....
EOD

&regchar('8',<<EOD);
xxxx
xxxx
xxxx
xxxx
xxxx
xxxx
xxxx
....
EOD

&regchar('9',<<EOD);
xxx*
xxx*
xxx*
xxx*
xxx*
xxx*
xxx*
....
EOD

&regchar('Q',<<EOD);
__*_
_.*_
_.*_
..**
...*
.*x*
...*
.*x*
EOD

&regchar('W',<<EOD);
...*
.*x*
...*
.*x*
...*
.*x*
...*
.*x*
EOD

&regchar('E',<<EOD);
...*
.*x*
...*
.*x*
...*
.*x*
...*
....
EOD

&regchar('R',<<EOD);
____
____
____
____
___.
__.x
_.xx
.xxx
EOD

&regchar('T',<<EOD);
___.
__.x
_.xx
.xxx
xxxx
xxxx
xxxx
xxxx
EOD

&regchar('Y',<<EOD);
*___
x*__
xx*_
xxx*
xxxx
xxxx
xxxx
xxxx
EOD

&regchar('U',<<EOD);
____
____
____
____
*___
x*__
xx*_
xxx*
EOD

&regchar('I',<<EOD);
.xxx
_.xx
__.x
___.
____
____
____
____
EOD

&regchar('O',<<EOD);
xxxx
xxxx
xxxx
xxxx
.xxx
_.xx
__.x
___.
EOD

&regchar('P',<<EOD);
xxxx
xxxx
xxxx
xxxx
xxx.
xx._
x.__
.___
EOD

&regchar('',<<EOD);
xxx.
xx._
x.__
.___
____
____
____
____
EOD

&regchar('Z',<<EOD);
*xxx
_***
_*xx
__**
__*x
___*
____
____
EOD

&regchar('X',<<EOD);
xxx*
***_
xx*_
**__
x*__
*___
____
____
EOD


&regchar('+',<<EOD);
xxxx
xx**
xx.*
x_..
x__x
x_xx
xxxx
xxxx
EOD

&regchar('!',<<EOD);
xxxx
x..x
..*.
....
....
....
x..x
xxxx
EOD

$consts.="chset_mono=$chridx\n";

&regch2(':',<<EOD);
qq.qq.qq
qqqqqqqq
qq.qq.qq
qqqqqqqq
qq.qq.qq
qqqqqqqq
qq.qq.qq
qqqqqqqq
EOD

&regch2('^',<<EOD);
qqq.qqqq
qq...qqq
q.....qq
qqqqqqqq
qqq.qqqq
qq...qqq
q.....qq
qqqqqqqq
EOD

# a  AH
# b  BB
# i  ?]
# j  ?J
# l  FL
# m  MH
# n  NH
# o  NV
# p  BF
# r  BH
# s  SJ
# t  ?/
# u  HV
# v  HV

&regch2i('M',<<EOD);
q.....q.
qq...qq.
qq...qq.
qqq.qqq.
qqqqqqq.
qqqqqqq.
qq.q.qq.
qq.q.qq.
EOD

&regch2i('H',<<EOD);
qq...qq.
qq...qq.
qq...qq.
qq...qq.
qq...qq.
qq...qq.
qq...qq.
qq...qq.
EOD

&regch2i('S',<<EOD);
..qqq...
.qqqqq..
qqqqqqq.
qq...qq.
qq......
qqqqqq..
.qqqqqq.
..qqqqq.
EOD

&regch2i('J',<<EOD);
.....qq.
.....qq.
qq...qq.
qq...qq.
qqqqqqq.
qqqqqqq.
.qqqqq..
..qqq...
EOD

&regch2i('A',<<EOD);
..qqq...
.qqqqq..
qqqqqqq.
qqq.qqq.
qq...qq.
qq...qq.
qqqqqqq.
qqqqqqq.
EOD

&regch2i('B',<<EOD);
qqqqq...
qqqqqq..
qqqqqqq.
qq...qq.
qq...qq.
qqqqqqq.
qqqqqqq.
qqqqqq..
EOD

&regch2i('F',<<EOD);
qq......
qq......
qq......
qq......
qq......
qq......
qq......
qq......
EOD

&regch2i('L',<<EOD);
qq......
qq......
qq......
qq......
qq......
qqqqqqq.
qqqqqqq.
qqqqqqq.
EOD

&regch2i('?',<<EOD);
.qqqqqq.
.qqqqqq.
.qqqqqq.
.....qq.
.....qq.
.....qq.
.....qq.
.....qq.
EOD

&regch2i('/',<<EOD);
.....qq.
.....qq.
.....qq.
.....qq.
.....qq.
.....qq.
.....qq.
.....qq.
EOD

&regch2i(']',<<EOD);
.....qq.
.....qq.
.....qq.
.....qq.
.....qq.
.qqqqqq.
.qqqqqq.
.qqqqqq.
EOD

&regch2i('N',<<EOD);
..qqq...
.qqqqq..
qqqqqqq.
qqqqqqq.
qq...qq.
qq...qq.
qq...qq.
qq...qq.
EOD

&regch2i('V',<<EOD);
qq...qq.
qq...qq.
qq...qq.
qq...qq.
qqqqqqq.
qqqqqqq.
.qqqqq..
..qqq..
EOD

&regch2('a',<<EOD);
...qqqq.
..qqqqq.
.qqqqqq.
qqq..qq.
qqqqqqq.
qq..qqq.
qq..qqq.
.....qq.
EOD

&regch2('b',<<EOD);
qqqqq...
qqqqqq..
qq..qqq.
qqqqqq..
qqq..qq.
qqq..qq.
qqqqqq..
........
EOD

&regch2('c',<<EOD);
...qqqq.
..qqqqq.
.qq.....
qq......
qqq.....
qqq.....
qqqqqqq.
........
EOD

&regch2('d',<<EOD);
qqqq....
qqqqq...
qq..qq..
qq...qq.
qqq..qq.
qqq..qq.
qqqqqqq.
........
EOD

&regch2('e',<<EOD);
...qqqq.
..qqqqq.
.qq.....
qqqqq...
qqq.....
qqq.....
qqqqqqq.
........
EOD

&regch2('f',<<EOD);
...qqqq.
..qqqqq.
.qq.....
qqqqq...
qq......
qq......
qq......
qq......
EOD

#&regch2('g',<<EOD);
#...qqqq.
#..qqqqq.
#.qq.....
#qq......
#qq..qqq.
#qq...qq.
#.qqqqqq.
#........
#EOD

&regch2('h',<<EOD);
....qq..
qq..qq..
qq..qq..
qqqqqqq.
qq..qqq.
qq..qqq.
qq..qqq.
qq......
EOD

&regch2('i',<<EOD);
.qqqqqq.
.qqqqqq.
...qq...
...qq...
..qqq...
..qqq...
qqqqqqq.
........
EOD

#&regch2('j',<<EOD);
#...qqqq.
#...qqqq.
#.....qq.
#.....qq.
#qq...qq.
#.qq..qq.
#..qqqqq.
#........
#EOD

&regch2('k',<<EOD);
qq...qq.
qq..qq..
qqqqq...
qqqqqq..
qq..qqq.
qq..qqq.
qq..qqq.
........
EOD

&regch2('l',<<EOD);
qq......
qq......
qq......
qqq.....
qqq.....
qqq.....
qqqqqqq.
........
EOD

&regch2('m',<<EOD);
qq...qq.
qqq.qqq.
qqqqqqq.
qqqqqqq.
qq.q.qq.
qq...qq.
qq...qq.
.....qq.
EOD

&regch2('n',<<EOD);
qqqq....
qqqqq...
qq..qq..
qq...qq.
qqq..qq.
qqq..qq.
qqq..qq.
.....qq.
EOD

&regch2('o',<<EOD);
...qqqq.
..qqqqq.
.qq..qq.
qq...qq.
qq...qq.
qq..qq..
qqqqq...
........
EOD

&regch2('p',<<EOD);
qqqqq...
qqqqqq..
qq..qqq.
qq..qqq.
qqqqqq..
qq......
qq......
qq......
EOD

#&regch2('q',<<EOD);
#...qqqq.
#..qqqqq.
#.qq..qq.
#qq...qq.
#qq.qqqq.
#qq..qqq.
#.qqqqq..
#.....qq.
#EOD

&regch2('r',<<EOD);
qqqqq...
qqqqqq..
qq..qqq.
qq..qqq.
qqqqqq..
qq..qqq.
qq...qq.
........
EOD

&regch2('s',<<EOD);
..qqqqq.
.qqqqqq.
qqq.....
.qqqqq..
.....qq.
qq..qq..
qqqqq...
........
EOD

&regch2('t',<<EOD);
qqqqqqq.
qqqqqqq.
...qq...
...qq...
..qqq...
..qqq...
..qqq...
........
EOD

&regch2('u',<<EOD);
qq...qq.
qq...qq.
qq...qq.
qq...qq.
qq...qq.
qqqqqqq.
.qqqqq..
........
EOD

&regch2('v',<<EOD);
qq...qq.
qq...qq.
qq...qq.
qq...qq.
.qq..qq.
..qqqqq.
...qqqq.
........
EOD

#&regch2('w',<<EOD);
#qq...qq.
#qq...qq.
#qq...qq.
#qq.q.qq.
#qqqqqqq.
#qqq.qqq.
#qq...qq.
#........
#EOD

&regch2('x',<<EOD);
qq...qq.
.qq..qq.
..qqqq..
...qq...
.qqqq...
qq..qq..
qq...qq.
........
EOD

&regch2('y',<<EOD);
qq...qq.
qq...qq.
qq...qq.
.qqqqqq.
....qqq.
....qqq.
qqqqqqq.
........
EOD

&regch2('z',<<EOD);
qqqqqq..
qqqqqqq.
....qq..
.qqqq...
qq......
qq......
qqqqqqq.
........
EOD


# 8x16

# I M P O S S I B L A T O R

# ***   ***   ***   ********
# ***  ***********  ***
# ***  ***********  ***
# ***  ***********  ***
# ***  *** *** ***  ***
# ***  *** *** ***  ***
# ***  ***     ***  ***
# ***  ***     ***  ***

#  deck   1222223
#         4555556
#         4512356
#         4545656
#         4578956
#         4555556
#         7888889

#  diag   RT222YU  RU RU
#         4555556

#  diag2  4555556
#         IO888P

# thinhull
#
#         Q      Q
#         W    RTWYU  <- "ohjaamo" tuohon?
#         W    78W89  pieni alus
#         E     REU

# diagonaaliset homostimet

# 

# - isot suuttimet pern
# 

# presents
# another demo			adehnor
# for the unexpanded vic zo	fitvxz
# five kb total ram		bkl
# one mhz cpu			cmpu
# tachyon explosion		sy

# no:				gjqw

# no: g

# ######################

#   FIVE KB TOTAL RAM
#
#   ONE MHZ CPU POWER

#

####################################################################

#    RTYU
#  R122223U
#  54555565
#  I788889
#    IOP

#   Q
#   W
#  QWQ
#12WEW23
#45W8W56
#IOW WP
#RTE2EYU
#IO123P
#RT456YU
#7878989

#          Q
#        RQWQU
#   Q    IWWW    Q
# RTWYU   WEW   RTWYU
# 78W89   E E   78W89
#  REU           REU

#    Q
#  Q W Q
# 1W2W2W3
# 7E8W8E9
#  RTEYU
#  IO5P
#  RT5YU
#  IO5P
#  RT5YU
#RT55555YU
#IOPEIOP

#   Q
# RQWQU
# 7WWW9
# IEEE
# R6 4U
# 76 47
# IO P

#         RQU
#       RT8W8YU
#       465W546
#       452W256
#       456E456
#       456 456
#       IO9 7P

#         RURU
#       RT5555YU
#     RT55!55!55YU
#   RT555555555555YU
# RT555555PIO555555YU
#2455555P    IO5555562
#8455555YU    RT5555568
# IO555555YURT555555P
#   IO555555555555P
#     IO55!55!55P
#       IO5555P
#         II
#   
#   
#   
#   Q   Q   Q   Q
#   E   E   E   E
 
 
######################
$origdata = <<EOD." \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n";














          Q
        RTWYU
        11W33
    Q   77W99   Q
    W   45E56   W
    W   79 79   W
Q   E   ZX ZX   E   Q
W                   W
W                   W
E                   E




         RQU
       RT8W8YU
       465W546
     QT452W256YQ
   RTW5456E4565WYU
 QT55W456 456IW55YQ
 W5PE IO9 7P EIO5W
 E               IE




       


RT22YU RU    RU RT22YU
458856 46    46 458856
46  46 46    46 46  46
46  46 46    46 46  46
452256 46 RU 46 452256
4588P 46 46 46 4588P
46     46T55Y46 46
46     45555556 46
46     45555556 46
I     IO8888P I


   p r e s e n t s






       Q  Q  Q
       WRTWYUW
   1YURW88W88WURT3
   4555W 4W6 W5556
   4555W22W22W5556
   7888W88W88W8889
   IOPWIOWPWIOP
       E  E  E








       RT2222YU
     RT55555555YU
   RT555555555555YU
 RT5555!5!55!5!5555YU
 45555555555555555556
 45122222222222222356
 45412312313123123656
 45445645646456456656
 45478978979789789656
 45788888888888888956
 45455555555555555656
 IO4555555555555556P
   455555!55!555556
   4556555555554556
   4556IO5555P4556
   4556  IOP  4556
   4556        4556
   4556        4556
   4556        4556
   4556 RURURU 4556
 RU4556 III 4556RU
 454556        455656
 45555622222222455556
 45555655555555455556
 78888922222222788889
 12222355555555122223
 45555688888888455556
 788889        788889
 ZXZXZX        ZXZXZX




     another demo

       for the

      unexpanded

        vic zo



  
   
U                    R
YU                RTI
 PYU            RTIO
   PYU        RTIO
     PYU    RTIO
       PYURTIO
23     12222223     12
56     45555556     45
56     45555556     45
2222222222222222222222
8888888888888888888888
56     45555556     45
56     45555556     45
89     78888889     78
          46
          46
          79
          13
          79
          13
          46
          46
  RU      46      RU 
  46      46      46
  46     1223     46
U 46     7889     46
6 46     1223     46
5Y46     7889     46T5
5556     1223     4555
5556     4886     4555
55P      46      IO55
I        46        I
          46
        RT22YU
      RT555555YU
    RT555!55!555YU
  RT55555555555555YU
RT5555++++++++++5555YU
555555+55555555+555555
555555+55122355+555555
55P45+55455655+56IO55
PRT55+55455655+55YUIO
RT5555+55788955+5555YU
555555+55555555+555555
55P45++++++++++56IO55
PRT55555555555555YUIO
RT5555555PIO5555555YU
5555555P    IO5555555
55555P        IO55555
555P            IO555
5P                IO5
                    I
   
   
   
  five kb total ram
   
   
   
     RURT222YURU
     IIO888PI
   
   
     
     one mhz cpu   
   
   
   
   
U        RTYU        R
5YU      4556      RT5
555YU    4556    RT555
55555YU  4556  RT55555
5555555YU4556RT5555555
555!55555555555555!555
5555555555555555555555
++++++++++++++++++++++
5555555555555555555555
5555555555555555555555
5588855888558885588855
56   46   46   46   45
56   46   46   46   45
56   46   46   46   45
56   46   46   46   45
5522255222552225522255
5555555555555555555555
5555555++++++++5555555
5588855+555555+5588855
56   45+5^55^5+56   45
56   45+555555+56   45
56   45+5^55^5+56   45
56   45+555555+56   45
5522255+5::::5+5522255
5555555+5::::5+5555555
5555555+5::::5+5555555
5588855+5::::5+5588855
56   45+5::::5+56   45
56   45+555555+56   45
56   45+5^55^5+56   45
56   45+555555+56   45
5522255+5^55^5+5522255
5555555+555555+5555555
5555555++++++++5555555
5555555555555555555555
!5!5!5!5!5!5!5!5!5!5!5
8888888888888888888888
   45556 45556 45556
   45556 45556 45556
   45556 45556 45556
   45556 45556 45556
  1222222222222222223
  4555555555555555556
  4558558558558558556
  456 46 46 46 46 456
  4552552552552552556
  4555555555555555556
  45^5^555555555^5^56
  4555555512355555556
  45:::5554!6555:::56
  45:::555789555:::56 
  45:::555555555:::56
  45:::512222235:::56
  45:::545555565:::56
  45:::545123565:::56
  45:::545456565:::56
  45:::545789565:::56
  45:::545555565:::56
  45:::545585565:::56
  45:::5456 4565:::56
  45:::545525565:::56
  4555557888889555556
  45^5^555555555^5^56
  4555555555555555556
  7888888888888888889
       123123123
     YU4!64!64!6P
   YU5578978978955P
 YU55P123123123IO55P
 4556  4!64!64!6  4556
 7889  789789789  7889
 ZXZX  123123123  ZXZX
       4!64!64!6
       789789789
  1222222222222222223
  4588888888888888856
  46   789789789   46
  46   123123123   46
  46   4!64!64!6   46
  46   789789789   46
  46   123123123   46
  46   4!64!64!6   46
  46   789789789   46
  4522222222222222256
YU5555555555555555555R
5555555555555555555555
5558888888888888888855
5565555555555555555545
55655?MBNSS?BFA?NB5545
55655]HFVJJ]BLH/VH5545
5565555555555555555545
55655!5!5!5!5!5!5!5545
5565555555555555555545
5552222222222222222255
5555555555555555555555
IO5555555555555555555P
  IO555555555555555P
    IO55555555555P
      45555555556
      45555555556
      45555555556
  1222455555555562223
  4555455555555565556
  4555455555555565556
  7888455555555568889
      45555555556
      45!5!5!5!56
      45555555556
      78888888889
       456456456
       456456456
       456456456
       456456456
       789789789
       ZXZX ZXZX
   




   
   
  













 
   

       alert   

  tachyon explosion



















                      
  tachyon explosion
EOD

# impossiblator
#
# imposblatr

# i m p o s s i p l A
# I M P O S S I B L a

# qqqqqq..
# qq......


# qqqqqqq.
# qqqqqqq.
# qqqqqqq.
# qq...qq.
# qq...qq.
# qq...qq.
# qq...qq.
# qq...qq.





# *
# *

# ........
# ........
# ........
# 

@stream=();
foreach(split("\n",$origdata))
{
  $_=sprintf('%-'.$width.'s',$_);

  print ">> $_ <<\n";

  foreach(split('',$_))
  {
     $z=$elements{$_};
     if($z eq '') { print "INVALID CHARACTER: $_\n"; exit 1; }
     push(@stream,$z);
  }
}

sub unz
{
  my $idx=$_[0];
  if(($idx>=0x8000) || ($idx<0)) { return 'ERR'; }


  if($zstream[$idx]<$symlimit) { return $zstream[$idx]; }
     else {
        my $nxidx=($zstream[$idx]+$idx+0xff00)&0xffff;
        return(&unz($nxidx),&unz($nxidx+1));
      }
}

@zstream=();$didx=0;$sidx=0;
while($sidx<=$#stream)
{
   $best=1;$where=$stream[$sidx];

   for($i=$symlimit;$i<0xff;$i++)
   {
      my $ndidx=($i+$didx+0xff00)&0xffff;
      @up=(&unz($ndidx),&unz($ndidx+1));

      my $lgt=$#up+1;

      if(($lgt>$best)&&(join(',',@up) ne 'ERR,ERR'))
      {
	 if(join(',',@up) eq join(',',@stream[$sidx..$sidx+$lgt-1])) { 
            $best=$lgt;$where=$i; 
#         print "sym $i == ",join(',',@up)," (lgt $lgt) -- cmp:",
#               join(',',@stream[$sidx..$sidx+$lgt-1]),"\n";
         }
      }
   }

#   print "[$didx] = $where\n";

   $zstream[$didx++]=$where;
#   @zstream=(@zstream,$symbol);
   $sidx+=$best;
}

# print "ORIGDATA:\n\n$origdata\n\nUNCOMPRESSED: ",join(',',@stream),"\n\n".

print "original data:   ".($#stream+1)." bytes\n".
      "compressed data: ".($#zstream+1)." bytes\n";

open F,">i_scroll.inc";
print F "scrolldata\n";
for($i=0;$i<=$#zstream-20;$i+=20) { print F ".byt ",join(',',@zstream[$i..$i+19]),"\n"; }
print F ".byt ",join(',',@zstream[$#zstream-19..$#zstream]),"\n";
#foreach(@zstream) { $l="$l
#byt ",join(',',@zstream),"\n\n";
close F;

open F,">i_scrpix.inc";
print F "chset_stars=$chridx\n$consts\n\npixeldata\n$pixeldata";
close F;

